<template>
  <form @submit.prevent="submit">

    <div v-bind:class="errorClassObject('email')" class="app__input--text">
      <p>メール<br />アドレス<span>必須</span></p>
      <input v-model="email" placeholder="例) hanako@shufu-job.jp">
    </div>
    <div v-bind:class="errorClassObject('password')" class="app__input--text">
      <p>パスワード<span>必須</span></p>
      <input v-model="password" type="password" placeholder="例) shufu1234">
    </div>
    <div v-bind:class="errorClassObject('passwordConfirm')" class="app__input--text">
      <p>パスワード確認用<span>必須</span></p>
      <input v-model="passwordConfirm" type="password" placeholder="確認のため再度入力してください">
    </div>

    <button type="submit" :disabled="isValid == false">同意して無料登録する</button>

  </form>
</template>

<script>
    //メールをチェックする正規表現
    const emailRE =/^[A-Za-z0-9]{1}[A-Za-z0-9_.-]*@{1}[A-Za-z0-9_.-]{1,}\.[A-Za-z0-9]{1,}$/

    export default{
      data(){
        return{
          email: "",
          password: "",
          passwordConfirm: ""
        }
      },
      computed: {
        validation() {
          return {
            email : (!!this.email && emailRE.test(this.email)),
            password : (!!this.password),
            passwordConfirm : (!!this.passwordConfirm && this.password === this.passwordConfirm),
          }
        },
        isValid(){
          const validation = this.validation
          return Object
          .keys(validation)
          .every(function (key){
            return validation[key]
          })
        }
      },
      methods:{
        errorClassObject(key) {
          return {
            'has-error': (this.validation[key] == false)
          }
        },
        submit() {
          // eslint-disable-next-line
          console.log('Success!');
        }
      }
    }
</script>

<style scoped>
    .has-error input {
        border: 1px solid #cccccc !important;
    }
    .app__input--text {
        width: 100%;
        display: flex;
    }
    .app__input--text p {
        width: 20%;
        font-size: 12px;
        text-align: right;
    }
    .app__input--text span {
        display: block;
        font-size: 12px;
        border: 1px solid #f87067;
        border-radius: 4px;
        padding: 0 3px;
        color: #fff;
        background: #f87067;
        width: 24px;
        margin-left: auto;
    }
    .app__input--text input {
        margin: 12px;
        height: 50px;
        width: 80%;
        border: 2px solid #32cd32;
        border-radius: 6px;
        padding:0px 12px;
    }
    :placeholder-shown {
        color: #cccccc !important;
    }
    button {
        text-decoration: none;
        background-color: #cccccc;
        border: 1px solid #cccccc;
        border-bottom: 4px solid #a9a9a9;
        width: 100%;
        margin: 0 auto;
        position: relative;
        vertical-align: middle;
        box-sizing: border-box;
        height: 55px;
        line-height: 50px;
        font-size: 18px;
        display: inline-block;
        font-weight: bold;
        text-align: center;
        color: #fff;
        border-radius: 5px;
    }
    button:valid {
      background-color: #068ee7;
      border: 1px solid #068ee7;
      border-bottom: 4px solid #006BAF;
    }
</style>